from CvPythonExtensions import *
from PyHelpers import *

# globals
gc = CyGlobalContext()

def canEverPlantForest(unit, action):
	if unit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_WORKER"):
		return True
	return False

def canPlantForestOnPlot(unit, plot, action):
	if plot.getFeatureType() != gc.getInfoTypeForString('FEATURE_FOREST') and plot.getFeatureType() != gc.getInfoTypeForString('FEATURE_JUNGLE'):
		return unit.atPlot(plot)
	return False

def plantForest(unit, plot, action):
	plot.setFeatureType(gc.getInfoTypeForString('FEATURE_FOREST'), 0)
	plot.setImprovementType(-1)
	unit.setMoves(unit.getMoves() + 60)

def canPlantForest(unit, action):
	plot = unit.plot()

	validTerrains = [
			gc.getInfoTypeForString("TERRAIN_GRASS"),
			gc.getInfoTypeForString("TERRAIN_PLAINS"),
			gc.getInfoTypeForString("TERRAIN_HILL")
			]
		
	if unit.canMove() and plot.getTerrainType() in validTerrains and plot.getFeatureType() != gc.getInfoTypeForString('FEATURE_FOREST') and plot.getFeatureType() != gc.getInfoTypeForString('FEATURE_JUNGLE'):
		return True
	return False

def shouldPlantForest(unit, action):
	pPlot = unit.plot()

	if pPlot.getImprovementType() == -1 and pPlot.getFeatureType() != gc.getInfoTypeForString('FEATURE_FOREST') and pPlot.getFeatureType() != gc.getInfoTypeForString('FEATURE_JUNGLE'):
		return True
	return False

def canEverBombard(unit, action):
	plot = unit.plot()
	if unit.getUnitCombatType() == gc.getInfoTypeForString("UNITCOMBAT_SIEGE"):
		return True
	return False

def canBombard(unit, action):
	if unit.getMoves() == unit.baseMoves() * 60:
		return False
	return True

def canBombardOnPlot(unit, plot, action):
	if plot.getNumDefenders(-1) > 0:
		if plot.getBestDefender(-1, unit.getOwner(), unit, True, True, True).isNone() == False:
			return True
	return False

def bombard(unit, plot, action):
	yUnit = plot.getBestDefender(-1, unit.getOwner(), unit, True, True, True)

	rand = CyGame().getSorenRandNum(90, 'Zebra9') + 10

	dmg = yUnit.getDamage()
	yUnit.setDamage(dmg + rand, -1)

	unit.setMoves(unit.getMoves() + 60)
	unit.setMadeAttack(True)

def shouldBombard(unit, action):
	return False

def getDistRangeFuncDiamond(maxDist,mustBeInSight=True):		## returns a function that gives a list of all the squares within a given distance
	plotDiffs = []							## [(dx,dy)]
	#precalculate the actual points, the inner function just moves them around
	for x in range(-maxDist,maxDist+1):				## need to include both
		for y in range(-maxDist,maxDist+1):			## need to include both
			if(x*x+y*y<=maxDist*maxDist):			## simple range formula
				plotDiffs.append((x,y))
	def inner(unit):
		start = unit.plot()
		startX = start.getX()
		startY = start.getY()
		plots = []
		map = gc.getMap()
		for delta in plotDiffs:					## move each point to center on the unit
			x = startX + delta[0]
			y = startY + delta[1]
			if mustBeInSight:
				if map.plot(x,y).isVisible(PyPlayer(unit.getOwner()).getTeamID(),false):
					plots.append((x, y))
			else:
				plots.append((x, y))
		return plots
	return inner

def getDistRangeFuncSquare(maxDist,mustBeInSight=True):			## returns a function that gives a list of all the squares within a given distance
	plotDiffs = []							## [(dx,dy)]
	#precalculate the actual points, the inner function just moves them around
	for x in range(maxDist*-1,maxDist+1):				## need to include both
		for y in range(maxDist*-1,maxDist+1):			## need to include both
			plotDiffs.append((x,y))

	def inner(unit):
		start = unit.plot()
		startX = start.getX()
		startY = start.getY()
		plots = []
		map = gc.getMap()
		for delta in plotDiffs:					## move each point to center on the unit
			x = startX + delta[0]
			y = startY + delta[1]
			if mustBeInSight:
				if map.plot(x,y).isVisible(PyPlayer(unit.getOwner()).getTeamID(),false):
					plots.append((x, y))
			else:
				plots.append((x, y))
		return plots
	return inner