# Sid Meier's Civilization 4
# Copyright Firaxis Games 2005
#
# CvEventInterface.py
#
# These functions are App Entry Points from C++
# WARNING: These function names should not be changed
# WARNING: These functions can not be placed into a class
#
# No other modules should import this
#
import CvUtil
import zActionsEventManager
from CvPythonExtensions import *

normalEventManager = zActionsEventManager.zActionsEventManager()

def getEventManager():
	return normalEventManager

def onEvent(argsList):
	'Called when a game event happens - return 1 if the event was consumed'
	#eventType,mx,my,px,py,interfaceConsumed,screens = argsList
	return getEventManager().handleEvent(argsList)

def applyEvent(argsList):
	#CyInterface().addImmediateMessage("applyEvent","")
	context, playerID, netUserData, popupReturn = argsList
	return getEventManager().applyEvent(argsList)

def beginEvent(context, argsList=-1):
	#CyInterface().addImmediateMessage("beginEvent","")
	return getEventManager().beginEvent(context, argsList)
