from CvPythonExtensions import *
from PyHelpers import *

gc = CyGlobalContext()

CURRENT_ACTION_NUMBER = -1
zActions = {}

class actionInfo:
	def __init__(self, name, buttonFile, rangeFunc, canDoAction, canEverDoAction, canDoActionPlot, isRecommended, doAction, maxRange):
		global CURRENT_ACTION_NUMBER
		self.__action = CURRENT_ACTION_NUMBER
		CURRENT_ACTION_NUMBER = CURRENT_ACTION_NUMBER -1
		self.__name = name
		self.__buttonFile = buttonFile
		self.__rangeFunc = rangeFunc				## rangeFunc is the tiles to be highlighted as targetable.
		self.__canEverDoAction = canEverDoAction
		self.__canDoAction = canDoAction
		self.__canDoActionPlot = canDoActionPlot
		self.__doAction = doAction
		self.__maxRange = maxRange
		self.__isActionRecommended = isRecommended
		zActions[self.__action] = self

	def getName(self):
		return self.__name

	def getActionNumber(self):
		return self.__action

	def getButton(self):
		return self.__buttonFile

	def getRange(self, unit):
		return self.__rangeFunc(unit)

	def canDoAction(self, unit):
		return self.__canDoAction(unit, self)

	def canEverDoAction(self, unit):
		return self.__canEverDoAction(unit, self)

	def canDoActionPlot(self, unit, plot):
		return self.__canDoActionPlot(unit, plot, self)

	def isActionRecommended(self, unit):
		return self.__isActionRecommended(unit, self)

	def doAction(self, unit, plot):
		return self.__doAction(unit, plot, self)

	def getMaxRange(self):
		return self.__maxRange

	def __str__(self):
		return self.__name

def needUnitCheckInRange(rangeFunc, unit, targetPlot):
	return targetPlot.getNumUnits() > 0 and (targetPlot.getX(), targetPlot.getY()) in rangeFunc(unit)

def getActionFromActionNum(action):
	return zActions.get(action)

def getActions():
	return zActions

def addZAction(name, buttonFile, rangeFunc, canDoAction, canEverDoAction, canDoActionPlot, isRecommended, doAction, maxRange):
	actionInfo(name, buttonFile, rangeFunc, canDoAction, canEverDoAction, canDoActionPlot, isRecommended, doAction, maxRange)