# American Revolution
# Civilization 4 (c) 2005 Firaxis Games

# Created by -	Jon 'Trip' Shafer
# Have fun!

from CvPythonExtensions import *
import sys
import pickle
import CvEventManager
from CvScreenEnums import *
from PyHelpers import *
import CvUtil
import zActionControls
# globals
gc = CyGlobalContext()
localText = CyTranslator()

DefaultUnitAI = UnitAITypes.NO_UNITAI
MY_PLOT_LAYER = PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_WORLD_BUILDER		## used for the selection cursor
MY_PLOT_LAYER2 = PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_REVEALED_PLOTS	## used for the range drawing

class zActionsEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		self.chooserActive = false					## when active, the user choosing a spot for a spell
		self.action = None
		CvEventManager.CvEventManager.__init__(self)

	def activatePlotChooser(self, action):
		self.chooserActive = true
		self.action = action
		
	#### overriden event handlers
	def onUpdate(self, argsList):						## called every frame
		if self.chooserActive and CyGame().GetWorldBuilderMode() == False:
			CyEngine().clearColoredPlots(MY_PLOT_LAYER)		## clear old stuff
			CyEngine().clearColoredPlots(MY_PLOT_LAYER2)
			
			pPlot = CyInterface().getMouseOverPlot()
			rangePlots = self.action.getRange(CyInterface().getHeadSelectedUnit())		## call the range function for the action

			if self.action.getMaxRange() > 0:
				#rangePlots is a list of x,y coordinate pairs in a tuple
				for plot in rangePlots:					## draw the range area
					CyEngine().addColoredPlotAlt(plot[0], plot[1], PlotStyles.PLOT_STYLE_TARGET, MY_PLOT_LAYER2, "COLOR_WHITE", .5)
	
				if(self.action.canDoActionPlot(CyInterface().getHeadSelectedUnit(), pPlot) and self.action.canDoAction(CyInterface().getHeadSelectedUnit())):		## draw the selection cursor - red if it can't be preformed there, green if it can
					for plot in rangePlots:
						if pPlot.getX() == plot[0] and pPlot.getY() == plot[1]:
							CyEngine().addColoredPlotAlt(pPlot.getX(), pPlot.getY(), PlotStyles.PLOT_STYLE_DOT_TARGET, MY_PLOT_LAYER, "COLOR_GREEN", 0.5)
							break
				else:
					for plot in rangePlots:
						if pPlot.getX() == plot[0] and pPlot.getY() == plot[1]:
							CyEngine().addColoredPlotAlt(pPlot.getX(), pPlot.getY(), PlotStyles.PLOT_STYLE_TARGET, MY_PLOT_LAYER, "COLOR_RED", 0.5)
							break
			else:
				zActionControls.preform(CyInterface().getHeadSelectedUnit(), self.action, CyInterface().getHeadSelectedUnit().plot())
				self.chooserActive = false 
				self.action = None
				CyEngine().clearColoredPlots(MY_PLOT_LAYER2) 	## clear the selection stuff
				CyEngine().clearColoredPlots(MY_PLOT_LAYER)

		CvEventManager.CvEventManager.onUpdate(self,argsList)
		
	def onMouseEvent(self, argsList):
		## mouse handler - returns 1 if the event was consumed
		eventType, mx, my, px, py, interfaceConsumed, screens = argsList
		if self.chooserActive and CyGame().GetWorldBuilderMode() == False:
			if eventType == 1:					## preform action
				self.chooserActive = false 
				zActionControls.preform(CyInterface().getHeadSelectedUnit(), self.action, CyInterface().getMouseOverPlot())
				self.action = None
				CyEngine().clearColoredPlots(MY_PLOT_LAYER2) 	## clear the selection stuff
				CyEngine().clearColoredPlots(MY_PLOT_LAYER)
				return 1

			elif(eventType == 3):
				self.chooserActive = false
				self.action = None
				CyEngine().clearColoredPlots(MY_PLOT_LAYER2)	## clear the selection stuff
				CyEngine().clearColoredPlots(MY_PLOT_LAYER)
				return 1

		return CvEventManager.CvEventManager.onMouseEvent(self,argsList)