from CvPythonExtensions import *
from PyHelpers import *

# globals
gc = CyGlobalContext()

def getDistRangeFuncDiamond(maxDist,mustBeInSight=True):		## returns a function that gives a list of all the squares within a given distance
	plotDiffs = []							## [(dx,dy)]
	#precalculate the actual points, the inner function just moves them around
	for x in range(-maxDist,maxDist+1):				## need to include both
		for y in range(-maxDist,maxDist+1):			## need to include both
			if(x*x+y*y<=maxDist*maxDist):			## simple range formula
				plotDiffs.append((x,y))
	def inner(unit):
		start = unit.plot()
		startX = start.getX()
		startY = start.getY()
		plots = []
		map = gc.getMap()
		for delta in plotDiffs:					## move each point to center on the unit
			x = startX + delta[0]
			y = startY + delta[1]
			if mustBeInSight:
				if map.plot(x,y).isVisible(PyPlayer(unit.getOwner()).getTeamID(),false):
					plots.append((x, y))
			else:
				plots.append((x, y))
		return plots
	return inner

def getDistRangeFuncSquare(maxDist,mustBeInSight=True):			## returns a function that gives a list of all the squares within a given distance
	plotDiffs = []							## [(dx,dy)]
	#precalculate the actual points, the inner function just moves them around
	for x in range(maxDist*-1,maxDist+1):				## need to include both
		for y in range(maxDist*-1,maxDist+1):			## need to include both
			plotDiffs.append((x,y))

	def inner(unit):
		start = unit.plot()
		startX = start.getX()
		startY = start.getY()
		plots = []
		map = gc.getMap()
		for delta in plotDiffs:					## move each point to center on the unit
			x = startX + delta[0]
			y = startY + delta[1]
			if mustBeInSight:
				if map.plot(x,y).isVisible(PyPlayer(unit.getOwner()).getTeamID(),false):
					plots.append((x, y))
			else:
				plots.append((x, y))
		return plots
	return inner